
% load('data_47.mat') 
% data=data_47;
load('data_46.mat') 
data=data_46;

%IOP_______________________
 %od=65;
 %do=75;
% d1=49; %pre IOP a oboch pacientov
% d2=49;
%__________________________________
%pac.46:    84-90
%pac.47:    81-93
 %d1=39; %pre ITS a oboch pacientov
 %d2=39;      
 %---------------------------------
 %d1=39; % x rozmer_anat_struktury uško
%d2=109; 
           % od=50; %pre oboch pacientov
           % do=62; 
 %_________________________________________________
% x rozmer_anat_struktury levy zvukovod
                    
%       d1=39;
%       d2=109;
%       od=39;
%       do=48;
   %------------------------------         
%             d1=29; % x rozmer_anat_struktury OKO
%             d2=29; 
%             %46: 89-96
%             od=61;
%             do=77; 
    %______________________________________
%             d1=54; % x rozmer_anat_struktury POE
%             d2=54; 
%             %46: 82-92
%             od=70;
%             do=78; 
%________________________________________

%             d1=29; % x rozmer_anat_struktury OKO ľavé
%             d2=29; 
%             %46: 82-88
%             od=54;
%             do=63; 
%______________________________________________________________
            d1=39; % x rozmer anat. struktury zvukovod
            d2=109; 
            od=50; %pre oboch pacientov (46 a 47)
            do=62;
            stred=floor(((do-od)/2)+od);
            rozdiel11=do-od+1;
            rozdiel=rozdiel11;
            pocetrezov=size(data);
            pocetrezov=pocetrezov(3);

imshow4(data); 
jeden_rez=data(:,:,stred); 
imshow(jeden_rez,[min(jeden_rez(:)) max(jeden_rez(:))]);%zobrazenie 1 rezu
hold on
bod=ginput(1);
hold off
pozitivne_detekcie11=cell(rozdiel,1); 
for i=od:do %na ktorých rezoch sa nachádza anat. štruktúra ktorú chceme vyreza?
    jeden_rez=data(:,:,i); %jeden rez s danou anat. štruktúrou
hold on %zadrží obraz, aby sa vyrezávanie uskuto?nilo v rovnakom obrázku 
anat_struktura=imcrop(jeden_rez,[bod,d1,d2]); %vyrezanie anat. štruktúry z daného rezu v tomto prípade sa jedná o vonkajší zvukovod, pre ktorý 
hold off
figure(i-(od-1)) %figure(1-12) = 12 okien
imshow(anat_struktura,[min(anat_struktura(:)) max(anat_struktura(:))]);
 pozitivne_detekcie11{i-(od-1)} = anat_struktura; %detekcie obsahujúce anatomickú štruktúru
 % do buniek uloží 12 anatomických štruktúr


end
d=pozitivne_detekcie11{1,1};%chceme vybra? prvú anatomickú štruktúru
figure(13)
imshow(d,[min(d(:)) max(d(:))]); %zobrazenie prvej vyrezanej anat. štruktrury

bez_anat_struktur=cell(rozdiel,1);
for j=od:do
jeden_rez=data(:,:,j);
H=imrect(gca,[bod, d1,d2]);
close all
jeden_rez(position(1,2):position(1,2)+position(1,4),position(1,1):position(1,1)+position(1,3))=0;
bez_anat_struktur{j-(od-1)}=jeden_rez;
end

g=bez_anat_struktur{1,1};
figure(14)
imshow(g,[min(g(:)) max(g(:))]);

%_________________________________________________________________
%VÝBER NÁHODNÝCH REZOV Z CELEJ DATABÁZY
x=ceil(0.8*rozdiel);
y=floor(0.2*rozdiel);

random_rez1=randi([1 (od-1)],1,x); 
random_rez2=randi([(do+1) pocetrezov],1,x);
random_rez=[random_rez1 random_rez2];

%---------------------------------------------------
%VYBER NAHODNYCH REZOV Z REZOV BEZ ANATOMICKYCH ŠTRUKTÚR
 random_rez_bez_anat=randperm(rozdiel);  


negativne_detekcie11=cell(rozdiel,1);


%VÝBER NÁHODNÝCH SÚRADNÍC
random_pozice_x=randi([1 512-d1],1,rozdiel); 
random_pozice_y=randi([1 512-d2],1,rozdiel);

     for p=1:x
       for r=x+1:rozdiel
          aktualna_pozice_x=random_pozice_x(p);
          aktualna_pozice_y=random_pozice_y(p);
          aktualna_pozice=[aktualna_pozice_x,aktualna_pozice_y];
           
        k=random_rez(p); %k= náhodné ?íslo z intervalu 1-327, pretože pacient 37 má 327 rezov
        %avšak okrem rezov 90-101
        nahodny_rez=data(:,:,k); %z dat (zoznamu rezov) sa vyberie náhodný rez 
        vystrihnute=imcrop(nahodny_rez,[aktualna_pozice,d1,d2]);
        negativne_detekcie11{p}=vystrihnute;
           
 %náhodné vyrezanie negatívnych detekcii z rezov BEZ ANATOMICKYCH STRUKTUR
 
        l=random_rez_bez_anat(r);
        nahodny_rez_bez_anat=bez_anat_struktur{l};
        
        %aktuálne súradnice pre rezy bez anatomickych štruktur
         aktualna_pozice_x2=random_pozice_x(r);
         aktualna_pozice_y2=random_pozice_y(r);
         aktualna_pozice2=[aktualna_pozice_x2,aktualna_pozice_y2];
         
       vystrihnute2=imcrop(nahodny_rez_bez_anat,[aktualna_pozice2,d1,d2]);
         negativne_detekcie11{r}=vystrihnute2;
       end
     end
        
 skuska=negativne_detekcie11{2};
 figure(15)
 imshow(skuska,[min(skuska(:)) max(skuska(:))]);
 %if data==data_46
 testovacie_pozitivne46=pozitivne_detekcie11;
 testovacie_negativne46=negativne_detekcie11;
 %else
% testovacie_pozitivne47=pozitivne_detekcie11;
% testovacie_negativne47=negativne_detekcie11;
% end
 bod(3)=od;
bod(4)=do;
 
 %save('MAE_oznacene47.mat','bod','d1','d2','testovacie_pozitivne46','testovacie_negativne46')
